CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                            Pio (Fortran)                            C
C                                                                     C
C                    Polyglot Input/Output Library                    C
C                                                                     C
C               EPI Pomdapi, INRIA Paris - Rocquencourt               C
C                                                                     C
C  Copyright 2005-2014 INRIA.                                         C
C  Institut National de Recherche en Informatique et en Automatique.  C
C  All rights reserved. This file is distributed only by permission.  C
C                                                                     C
C  Francois Clement <Francois.Clement@inria.fr>                       C
C  Pierre Weis <Pierre.Weis@inria.fr>                                 C
C  Hend Ben Ameur <hbenameur@yahoo.ca>                                C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C $Id: pio_utils.fpp,v 1.2 2014/03/14 11:07:39 fclement Exp $

#include "pio_constants.h"

      integer function get_size_layout(sbr, sizev, layoutv, j)
C     Get the j-th size according to the layout.
      
      implicit none
      
C     Input arguments.
      character sbr*(*)
      integer sizev(*), layoutv(*), j
      
C     Local variables.
      integer lyj, szj
      
C     External function.
      logical pio_get_debug_mode
      
      lyj = layoutv(j)
      szj = sizev(lyj + 1)
      
      if (pio_get_debug_mode()) then
         write(PIO_DEBUG, *) '[Pio/Fortran] In ', sbr, ', ',
     +        'j = ', j, ', layoutv = ', lyj, ', sizev = ', szj
      endif
      
      get_size_layout = szj
      
      return
      end


      subroutine row_number_and_size
     +     (sbr, what, pv, sizev, layoutv, nb_row, sz)
C     Compute the number of rows and their size for multi-d array
C     values.
      
      implicit none
      
C     Input arguments
      character sbr*(*), what*(*)
      integer pv, sizev(*), layoutv(*)
      
C     Output arguments.
      integer nb_row, sz
      
C     Local variables.
      integer j, szj
      
C     External functions.
      logical pio_get_debug_mode
      integer get_size_layout
      
      nb_row = 1
      
      do j = 1, pv - 1
         szj = get_size_layout(sbr, sizev, layoutv, j)
         nb_row = nb_row * szj
      enddo
      
      sz = get_size_layout(sbr, sizev, layoutv, pv)
      
      if (pio_get_debug_mode()) then
         write(PIO_DEBUG, *) '[Pio/Fortran] In ', sbr, ', ',
     +        nb_row, ' rows of size ', sz,' to be ', what
      endif
      
      return
      end
